﻿using Admin.Models;
using BLL;
using Common;
using Common.Image;
using Models.View;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace Admin.Controllers
{
    public class AccountController : Controller
    {
        private AdminBll adminBll = new AdminBll();
        public ActionResult Index()
        {
            return View();
        }
        public void GenrateImage()
        {
            MyPic m = new MyPic(100, 60);
            var tempResult = m.DrawZimu();
            Session[KeyContain.VERIFKEY] = tempResult.Item2;
            tempResult.Item1.Save(Response.OutputStream, System.Drawing.Imaging.ImageFormat.Jpeg);
        }
        [ValidateAntiForgeryToken, HttpPost]
        public ActionResult Login(ViewLogin model)
        {
            ResponeBase result = new ResponeBase
            {
                Code = ResponeCode.No
            };
            if (!Request.IsAjaxRequest())
            {
                result.Msg = "非法请求";
            }
            else
            {
                if (!ValidCode(model.ValidCode))
                {
                    result.Msg = "验证码错误";
                }
                else
                {
                    var admin = adminBll.AdminLogin(model);
                    if (admin != null)
                    {
                        result.Code = ResponeCode.Ok;
                        Session[KeyContain.ADMIN] = admin;
                        result.Url = KeyContain.HOMEINDEX;
                    }
                    else
                    {
                        result.Msg = "密码错误或用户名不存在";
                    }
                }
            }
            return Json(result);
        }
        private bool ValidCode(string code)
        {
            return string.Equals(code, Session[KeyContain.VERIFKEY].ToString(), StringComparison.CurrentCultureIgnoreCase);
        }
    }
}