﻿using Admin.Models;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace Admin.Controllers
{
    public class FilterController : Controller
    {
        [HttpPost]
        public ActionResult UploadFile(HttpPostedFileBase file)
        {
            var path = GeneratePath() + Path.GetExtension(file.FileName);
            file.SaveAs(System.AppDomain.CurrentDomain.BaseDirectory + path);
            ResponeFile rs = new ResponeFile();
            rs.data.src = path;
            rs.data.title = file.FileName;
            rs.code = 0;
            return Json(rs);
        }
        private string GeneratePath()
        {
            var currentDir = $"/FileWeb/{DateTime.Now.ToString("yyyy-MM-dd")}/";
            var resutldir = System.AppDomain.CurrentDomain.BaseDirectory + currentDir;
            if (!Directory.Exists(resutldir))
            {
                Directory.CreateDirectory(resutldir);
            }

            currentDir += Guid.NewGuid().ToString("n");
            return currentDir;
        }
        /// <summary>
        /// 单选框分部视图
        /// </summary>
        /// <param name="model"></param>
        /// <returns></returns>
        public ActionResult Radio(RequestRadio model)
        {
            return View(model);
        }
    }

    public class ResponeFile
    {
        public ResponeFile()
        {
            this.data = new FileData();
        }
        /// <summary>
        /// 代码
        /// </summary>
        public int code = 0;

        public string msg;

        public FileData data;
    }
    public class FileData
    {
        public string src;
        public string title;
    }
}