﻿using Common;
using DbKernel;
using Models;
using Models.View;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Dapper;
namespace BLL
{
    public class AuthenBll : BaseBll
    {

        public PageResult List(PageRequest page)
        {
            int total;
            var result = SqlProvider.DataPage<vm_UserAuthen>("vm_UserAuthen", "*", "", " AddTime ", page.PageSize, page.PageIndex, out total);
            return result.GeneratePageResult(page, total);
        }
        public int AddAuthen(ViewAuthen model)
        {
            DynamicParameters pa = new DynamicParameters();
            pa.AddDynamicParams(model);
            pa.Add("@return", dbType: System.Data.DbType.Int32, direction: System.Data.ParameterDirection.ReturnValue);
            SqlProvider.SP_Execute("proc_AddAuthen", pa);
            return pa.Get<int>("@return");
        }
        public int UserIsAuthen(int UserId)
        {
            DynamicParameters pa = new DynamicParameters();
            pa.Add("@id", UserId);
            pa.Add("@return", dbType: System.Data.DbType.Int32, direction: System.Data.ParameterDirection.ReturnValue);
            SqlProvider.SP_Execute("proc_UserExistsAu", pa);
            return pa.Get<int>("@return");
        }
        public int AuthenPass(int UserId)
        {
            DynamicParameters pa = new DynamicParameters();
            pa.Add("@id", UserId);
            return SqlProvider.SP_Execute("proc_AuthenPass", pa);
        }
        public ViewUserAuthen ViewAuthen(int useId)
        {
            DynamicParameters dy = new DynamicParameters();
            dy.Add("@id", useId);
            return SqlProvider.SP_QueryFirst<ViewUserAuthen>(@"select top 1 
ta.CodeNumber,ta.RealeName,ta.Photo,tc.Name as CityName from [tb.Authen] ta left join 
[tb.City] tc on ta.CityId=tc.ID where UserId=@id", dy, System.Data.CommandType.Text);
        }
    }
}
