﻿using Common;
using DbKernel;
using Models.View;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Dapper;
using Models.Page;

namespace BLL
{
    public class TransRecordBll : BaseBll
    {
        public PageResult List(PageRequest page)
        {
            int total;
            var result = SqlProvider.DataPage<vm_TransRecord>("vm_TransRecord", "*", page.StrWhere,
                " AddTime ", page.PageSize, page.PageIndex, out total);
            return result.GeneratePageResult(page, total);
        }
        public PageResult ViewList(PageRequest page)
        {
            int total;
            var result = SqlProvider.DataPage<PageTransRecord>("vm_TransRecord", "SucessTime,[Type],Price",
                $"SendId={page.StrWhere} or ReviceId={page.StrWhere}", " AddTime desc ", page.PageSize, page.PageIndex, out total);
            return result.GeneratePageResult(page, total);
        }
        public int AdminAdd(ViewAdminTransRecord model)
        {
            DynamicParameters pa = new DynamicParameters();
            pa.Add("@re", model.ReviceId);
            pa.Add("@price", model.Price);
            pa.Add("@desc", model.Descript);
            return SqlProvider.SP_Execute("proc_TransRecordAdminAdd", pa);
        }
        public int Trans(ViewTransRecord model)
        {
            DynamicParameters pa = new DynamicParameters();
            pa.AddDynamicParams(model);
            pa.Add("@return", dbType: System.Data.DbType.Int32, direction: System.Data.ParameterDirection.ReturnValue);
            SqlProvider.SP_Execute("proc_UserTrans", pa);
            return pa.Get<int>("@return");
        }
        public int DeletedTrans(int Id)
        {
            DynamicParameters pa = new DynamicParameters();
            pa.Add("@id", Id);
            pa.Add("@return", dbType: System.Data.DbType.Int32, direction: System.Data.ParameterDirection.ReturnValue);
            SqlProvider.SP_Execute("proc_RevokeTransRecord", pa);
            return pa.Get<int>("@return");
        }
    }
}
