﻿using Common;
using Models;
using Models.View;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using DbKernel;
using Dapper;
using Models.Page;
namespace BLL
{
    public class UserBll : BaseBll
    {

        public bool Register(ViewUserRegister model)
        {
            string identity = string.Empty;
            int Depth = 0;
            while ((++Depth) <= 5)
            {
                DynamicParameters pa = new DynamicParameters();
                identity = Tool.GenerateGuidByNumber(26);
                pa.Add("@identity", identity);
                var returnInt = SqlProvider.SP_QueryFirst<int>("select count(1) from [tb.User] where UserIdentity=@identity", pa, System.Data.CommandType.Text);
                if (returnInt == 0)
                {
                    break;
                }
            }
            if (Depth > 5)
            {
                return false;
            }
            DynamicParameters pauser = new DynamicParameters();
            pauser.Add("@Email", model.ReEmail);
            pauser.Add("@Password", model.RePassword);
            pauser.Add("@UserIdentity", identity);
            pauser.Add("@return", dbType: System.Data.DbType.Int32, direction: System.Data.ParameterDirection.ReturnValue);
            if (SqlProvider.SP_Execute("[dbo].[proc_RegisterUser]", pauser) > 0)
            {
                int i = pauser.Get<int>("@return");
                if (i > 0)
                {
                    return true;
                }
            }
            return false;
        }

        public User Login(ViewUserLogin model)
        {
            DynamicParameters pa = new DynamicParameters();
            pa.Add("@email", model.Email);
            pa.Add("@pwd", model.Password);
            var i = SqlProvider.SP_QueryFirst<User>("select * from [tb.User] where Email=@email and [Password]=@pwd", pa, System.Data.CommandType.Text);
            return i;
        }
        public int ChangePwd(ViewUserChangePwd model)
        {
            DynamicParameters pa = new DynamicParameters();
            pa.Add("@UserId", model.UserId);
            pa.Add("@OriginPwd", model.OriginPwd);
            pa.Add("@ConfigPwd", model.ConfigPwd);
            pa.Add("@type", model.PasswordType);
            pa.Add("@return", dbType: System.Data.DbType.Int32, direction: System.Data.ParameterDirection.ReturnValue);
            SqlProvider.SP_Execute("proc_ChangeUserLogingPwd", pa);
            return pa.Get<int>("@return");
        }

        public ViewBalance GetBalance(int userId)
        {
            DynamicParameters pa = new DynamicParameters();
            pa.Add("@UserId", userId);
            return SqlProvider.SP_QueryFirst<ViewBalance>("proc_UserBalance", pa);
        }
        public string GetUserIdentiry(int userId)
        {
            DynamicParameters pa = new DynamicParameters();
            pa.Add("@id", userId);
            return SqlProvider.SP_QueryFirst<string>("SELECT UserIdentity FROM dbo.[tb.User] WHERE UserId=@id", pa, System.Data.CommandType.Text);
        }
        public string GetUserEmailByIdentiry(string identiry)
        {
            DynamicParameters pa = new DynamicParameters();
            pa.Add("@identity", identiry);
            return SqlProvider.SP_QueryFirst<string>("SELECT Email FROM dbo.[tb.User] WHERE UserIdentity=@identity", pa, System.Data.CommandType.Text);
        }
        public PageResult Page(PageRequest page)
        {
            string Where = "";
            int total;
            var key = "Email";
            if (page.Filter.ContainsKey(key))
            {
                var val = page.Filter[key];
                Where += $"{key} like '%{val}%'";
            }
            var list = SqlProvider.DataPage<PageUser>("[tb.User]", " UserId,Email ", Where, "AddTime desc", page.PageSize, page.PageIndex, out total);
            return Tool.GeneratePageResult(list, page, total);
        }
    }
}
