﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
namespace Common
{
    /// <summary>
    /// 分页请求类
    /// </summary>
    public class PageRequest
    {
        public PageRequest()
        {
            FilterField = new List<string>();
            SortField = new List<string>();
        }
        private int _pageIndex = 1;
        private int _pageSize = 10;
        /// <summary>
        /// 需要过滤的字段
        /// </summary>
        public IList<string> FilterField { get; set; }

        private Dictionary<string, string> _filter;
        public Dictionary<string, string> Filter
        {
            get
            {
                try
                {
                    if (_filter == null)
                    {
                        _filter = new Dictionary<string, string>();
                        FilterField.ToList().ForEach(d =>
                        {
                            var vals = d.Split('|');
                            var key = vals[0].Trim();
                            var val = vals[1].Trim();
                            if (string.IsNullOrWhiteSpace(val))
                            {
                                return;
                            }
                            _filter[key] = val;
                        });
                    }
                    return _filter;
                }
                catch (Exception)
                {
                    return new Dictionary<string, string>();
                }

            }
        }

        public string StrFild { get; set; }

        public string StrWhere
        {
            get;set;
        }
        /// <summary>
        /// 需要排序的字段
        /// </summary>
        public IList<string> SortField { get; set; }
        public int PageIndex
        {
            get { return _pageIndex; }
            set
            {
                _pageIndex = value;
            }
        }
        public int PageSize
        {
            get { return _pageSize; }
            set
            {
                _pageSize = value;
            }
        }

        public int SkipCount
        {
            get
            {
                return (_pageIndex - 1) * _pageSize;
            }
        }
    }
}
