﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Common
{
    /// <summary>
    /// 通用返回接口
    /// </summary>
    public class ResponeBase
    {
        /// <summary>
        /// 返回成功码
        /// </summary>
        public ResponeCode Code = ResponeCode.Ok;

        private string msg;
        /// <summary>
        /// 返回消息
        /// </summary>
        public string Msg
        {
            get
            {
                if (string.IsNullOrWhiteSpace(msg))
                {
                    switch (this.Code)
                    {
                        case ResponeCode.Ok:
                            this.msg = "成功";
                            break;
                        case ResponeCode.No:
                            this.msg = "失败";
                            break;
                        default:
                            break;
                    }
                }
                return this.msg;
            }
            set
            {
                msg = value;
            }
        }
        /// <summary>
        /// 返回的数据
        /// </summary>
        public object Data;
        /// <summary>
        /// 是否关闭打开的窗口
        /// </summary>
        public bool IsClose { get; set; } = true;
        /// <summary>
        /// 重定向地址
        /// </summary>
        public string Url = "";
    }
    public enum ResponeCode
    {
        Ok = 200,
        No = 500
    }
}
