﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Common;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel;
namespace Models.View
{
    public class ViewChangePwd
    {
        private string _originPwd;
        /// <summary>
        /// 原密码
        /// </summary>
        [DisplayName("原密码")]
        [Required(ErrorMessage ="请输入原密码")]
        [RegularExpression(RegexEx.PWD,ErrorMessage ="密码格式不正确,只支持英文和数字")]
        [UIHint("LayuiInput")]
        public string OriginPwd
        {
            get
            {
                if (!string.IsNullOrWhiteSpace(_originPwd))
                {
                    return _originPwd.MD5();
                }
                return string.Empty;
            }
            set
            {
                _originPwd = value;
            }
        }

        private string _newPwd;
        /// <summary>
        /// 新密码
        /// </summary>
        [Required(ErrorMessage = "请输入新密码")]
        [DisplayName("新密码")]
        [RegularExpression(RegexEx.PWD, ErrorMessage = "密码格式不正确,只支持英文和数字")]
        [UIHint("Password")]
        public string NewPwd
        {
            get
            {
                if (!string.IsNullOrWhiteSpace(_newPwd))
                {
                    return _newPwd.MD5();
                }
                return string.Empty;
            }
            set
            {
                _newPwd = value;
            }
        }

        public string _configPwd;
        /// <summary>
        /// 确认密码
        /// </summary>
        [DisplayName("确认密码")]
        [Required(ErrorMessage = "请输入确认密码")]
        [RegularExpression(RegexEx.PWD, ErrorMessage = "密码格式不正确,只支持英文和数字")]
        [UIHint("Password")]
        [Compare("NewPwd", ErrorMessage = "两次输入的密码不一致")]
        public string ConfigPwd
        {
            get
            {
                if (!string.IsNullOrWhiteSpace(_configPwd))
                {
                    return _configPwd.MD5();
                }
                return string.Empty;
            }
            set
            {
                _configPwd = value;
            }
        }
    }
}
