﻿using Common;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Models.View
{
    /// <summary>
    /// 转账视图类
    /// </summary>
    public class ViewTransRecord
    {
        /// <summary>
        /// 转账编号
        /// </summary>
        public int UserId { get; set; }
        /// <summary>
        /// 收款人账号
        /// </summary>
        [DisplayName("收款人账号")]
        [Required(ErrorMessage = "请输入收款人账号")]
        public string RecerName { get; set; }

        private string password = "";
        /// <summary>
        /// 支付密码
        /// </summary>
        [DisplayName("支付密码")]
        [Required(ErrorMessage = "请输入支付密码")]
        [RegularExpression(RegexEx.PWD, ErrorMessage = "格式错误")]
        public string Password
        {
            get
            {
                if (!string.IsNullOrWhiteSpace(password))
                {
                    return password.MD5();
                }
                return "";
            }
            set
            {
                password = value;
            }
        }
        /// <summary>
        /// 支付金额
        /// </summary>
        [DisplayName("支付金额")]
        [Required(ErrorMessage = "请输入支付金额")]
        [RegularExpression(RegexEx.NUMBER, ErrorMessage = "格式错误")]
        public decimal Price { get; set; }
    }
}
