﻿using Common;
using Models.Enum;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Models.View
{
    public class ViewUserChangePwd
    {
        /// <summary>
        /// 密码类型
        /// </summary>
        [DisplayName("密码类型")]
        [Required(ErrorMessage = "请选择类型")]
        public PasswordType PasswordType { get; set; }
        public int UserId { get; set; }
        private string _originPwd;
        /// <summary>
        /// 原密码
        /// </summary>
        [DisplayName("原密码")]
        [Required(ErrorMessage = "请输入原密码")]
        [RegularExpression(RegexEx.PWD, ErrorMessage = "格式错误")]
        public string OriginPwd
        {
            get
            {
                if (!string.IsNullOrWhiteSpace(_originPwd))
                {
                    return _originPwd.MD5();
                }
                return string.Empty;
            }
            set
            {
                _originPwd = value;
            }
        }

        private string _newPwd;
        /// <summary>
        /// 新密码
        /// </summary>
        [Required(ErrorMessage = "请输入新密码")]
        [DisplayName("新密码")]
        [RegularExpression(RegexEx.PWD, ErrorMessage = "格式错误")]
        public string NewPwd
        {
            get
            {
                if (!string.IsNullOrWhiteSpace(_newPwd))
                {
                    return _newPwd.MD5();
                }
                return string.Empty;
            }
            set
            {
                _newPwd = value;
            }
        }
        public string _configPwd;
        /// <summary>
        /// 确认密码
        /// </summary>
        [DisplayName("确认密码")]
        [Required(ErrorMessage = "请输入确认密码")]
        [RegularExpression(RegexEx.PWD, ErrorMessage = "格式错误")]
        [Compare("NewPwd", ErrorMessage = "两次输入的密码不一致")]
        public string ConfigPwd
        {
            get
            {
                if (!string.IsNullOrWhiteSpace(_configPwd))
                {
                    return _configPwd.MD5();
                }
                return string.Empty;
            }
            set
            {
                _configPwd = value;
            }
        }
    }
}
