﻿
using BLL;
using Common;
using Models.View;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Security;
using Web.App_GlobalResources;
using Web.Modles;
using System.Resources;
namespace Web.Controllers
{
    public class HomeController : Controller
    {
        private AjaxRespone AjaxRespone = new AjaxRespone();
        private UserBll UserBll = new UserBll();
        ConfigBll ConfigBll = new ConfigBll();
        public ActionResult Index()
        {
            ViewBag.Booke = ConfigBll.GetTopOne().DcAddress;
            return View();
        }
        [ChildActionOnly]
        public ActionResult Center()
        {
            return View();
        }
        [ChildActionOnly]
        public ActionResult Footer()
        {
            return View();
        }
        /// <summary>
        /// 发送邮箱验证码
        /// </summary>
        /// <returns></returns>
        /// 
        [ValidateInput(false)]
        public ActionResult SendEmail(SendEmail model)
        {
            AjaxRespone re = new AjaxRespone();
            try
            {
                var config = ConfigBll.GetTopOne();
                var code = Tool.GenerateGuidByNumber(4);
                Session[KeyHelper.EmailKey] = code;
                string tital = "";
                switch (model.EmailType)
                {
                    case EmailType.register:
                        tital = Message.Register_Code;
                        break;
                    case EmailType.fpassword:
                        tital = Message.Fpassword_Code;
                        break;
                    default:
                        break;
                }
                EmailUtils.SendMail(model.Email, $"{Message.SiteName} {tital}", code, config.EmailAddress, config.EmailHost, config.EmailPassword);
                re.Code = 2;
            }
            catch (Exception ex)
            {
                re.Msg = ex.Message;
            }
            return Json(re, JsonRequestBehavior.AllowGet);
        }
        #region 注册
        [ChildActionOnly]
        public ActionResult Register()
        {
            return View();
        }
        [HttpPost, ValidateAntiForgeryToken]
        public ActionResult Register(ViewUserRegister model)
        {
            if (!Request.IsAjaxRequest())
            {
                AjaxRespone.Msg = "请求非法";
                return Json(AjaxRespone);
            }
            if (!CheckEmailCode(model.ReValidCode))
            {
                AjaxRespone.Msg = "验证码错误";
                return Json(AjaxRespone);
            }
            var result = UserBll.Register(model);
            if (result)
            {
                AjaxRespone.Msg = "注册成功";
            }
            else
            {
                AjaxRespone.Msg = "注册失败";
            }
            return Json(AjaxRespone);
        }
        #endregion
        #region 重置密码
        public ActionResult ForgetPassword()
        {
            return View();
        }
        public ActionResult Luange()
        {
            ViewBag.lunage = RouteData.Values["lange"].ToString();
            return View();
        }
        [HttpPost, ValidateAntiForgeryToken]
        public ActionResult ForgetPassword(int ttt)
        {
            return View();
        }
        #endregion
        private bool CheckEmailCode(string va)
        {
            try
            {
                var code = Session[KeyHelper.EmailKey].ToString();
                bool b = string.Equals(va, code, StringComparison.CurrentCultureIgnoreCase);
                Session.Remove(KeyHelper.EmailKey);
                return b;

            }
            catch (Exception)
            {

                return false;
            }
        }
        [ChildActionOnly, AllowAnonymous]
        public ActionResult Login()
        {
            return View();
        }
        private bool CheckValidCode(string code)
        {
            try
            {
                var verifkey = Session[KeyHelper.VERIFKEY].ToString();
                return string.Equals(code, verifkey, StringComparison.CurrentCultureIgnoreCase);
            }
            catch
            {
                return false;
            }
        }

        [HttpPost, ValidateAntiForgeryToken]
        public ActionResult Login(ViewUserLogin model)
        {
            if (!Request.IsAjaxRequest())
            {
                AjaxRespone.Msg = "请求非法";
                return Json(AjaxRespone);
            }
            if (!CheckValidCode(model.ValidCode))
            {
                AjaxRespone.Msg = "验证码错误";
                return Json(AjaxRespone);
            }
            var result = UserBll.Login(model);
            if (result != null)
            {
                SetCookie(result, model.IsRemember);
                AjaxRespone.Msg = "登录成功";
                AjaxRespone.Url = KeyHelper.CENTER;
                AjaxRespone.Code = 1;
            }
            else
            {
                AjaxRespone.Msg = "登录失败";
            }
            return Json(AjaxRespone);
        }
        private void SetCookie(object o, bool isRegister)
        {
            string strName = FormsAuthentication.FormsCookieName;
            FormsAuthenticationTicket tick = new FormsAuthenticationTicket(1, strName, DateTime.Now, isRegister ? DateTime.Now.AddYears(1) : DateTime.Now.AddMinutes(20), true, o.SerializeIgnore());
            HttpCookie cookie = new HttpCookie(strName);
            cookie.Value = FormsAuthentication.Encrypt(tick);
            cookie.Domain = FormsAuthentication.CookieDomain;
            Response.Cookies.Remove(strName);
            Response.Cookies.Add(cookie);
        }

    }
}