﻿using BLL;
using Common;
using Models.View;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Web.Filter;

namespace Web.Controllers
{
    public class OrderController : BaseController
    {
        UserBll UserBll = new UserBll();
        TransRecordBll TransRecordBll = new TransRecordBll();
        public ActionResult Index()
        {
            ViewBag.identity = CurrentUser.UserIdentity;
            return View();
        }
        public ActionResult OrderDetail()
        {
            ViewBag.id = CurrentUser.UserId;
            return View();
        }
        [HttpPost]
        public ActionResult TransRecord(PageRequest model)
        {
            return Json(TransRecordBll.ViewList(model));
        }
        /// <summary>
        /// 转账页面
        /// </summary>
        /// <param name="u"></param>
        /// <returns></returns>
        public ActionResult Trans(string u)
        {
            //得到用户余额
            var result = UserBll.GetBalance(CurrentUser.UserId);
            var ree = new ViewTransRecord();
            if (!string.IsNullOrWhiteSpace(u))
            {
                ree.RecerName = UserBll.GetUserEmailByIdentiry(u);
            }
            ViewBag.balance = result;
            return View(ree);
        }
        [HttpPost, ValidateAntiForgeryToken]
        public ActionResult Trans(ViewTransRecord model)
        {
            model.UserId = CurrentUser.UserId;
            var n = TransRecordBll.Trans(model);
            switch (n)
            {
                case -2: AjaxRespone.Msg = "余额不足,或支付密码错误"; break;
                case -1: AjaxRespone.Msg = "收款用户不存在"; break;
                default: { AjaxRespone.Code = 1; AjaxRespone.Msg = "转账成功"; } break;
            }
            return Json(AjaxRespone);
        }
    }
}