﻿using BLL;
using Models.View;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Web.Modles;
using System.Web.Security;
using Common;
using System.Configuration;
using Models.Enum;
using System.Web.Caching;
namespace Web.Controllers
{
    public class UserController : BaseController
    {
        private static string path = ConfigurationManager.AppSettings["RqCode"].ToString();
        private UserBll UserBll = new UserBll();
        private void SetCookie(object o, bool isRegister)
        {
            string strName = FormsAuthentication.FormsCookieName;
            FormsAuthenticationTicket tick = new FormsAuthenticationTicket(1, strName, DateTime.Now, isRegister ? DateTime.Now.AddYears(1) : DateTime.Now.AddMinutes(20), true, o.SerializeIgnore());
            HttpCookie cookie = new HttpCookie(strName);
            cookie.Value = FormsAuthentication.Encrypt(tick);
            cookie.Domain = FormsAuthentication.CookieDomain;
            Response.Cookies.Remove(strName);
            Response.Cookies.Add(cookie);
        }
        [HttpPost, ValidateAntiForgeryToken]
        public ActionResult Register(ViewUserRegister model)
        {
            try
            {
                if (!Request.IsAjaxRequest())
                {
                    AjaxRespone.Msg = "请求非法";
                    return Json(AjaxRespone);
                }
                if (!CheckEmailCode(model.ReValidCode))
                {
                    AjaxRespone.Msg = "验证码错误";
                    return Json(AjaxRespone);
                }
                var result = UserBll.Register(model);
                if (result)
                {
                    AjaxRespone.Msg = "注册成功";
                }
                else
                {
                    AjaxRespone.Msg = "注册失败";
                }
            }
            catch (Exception ex)
            {
                AjaxRespone.Msg = ex.Message;
            }
            return Json(AjaxRespone);
        }
        public ActionResult ChangePwd()
        {
            return View();
        }
        private bool CheckEmailCode(string va)
        {
            try
            {
                var code = Session[KeyHelper.EmailKey].ToString();
                bool b = string.Equals(va, code, StringComparison.CurrentCultureIgnoreCase);
                Session.Remove(KeyHelper.EmailKey);
                return b;

            }
            catch (Exception)
            {

                return false;
            }
        }
        [HttpPost, ValidateAntiForgeryToken]
        public ActionResult ChangePwd(ViewUserChangePwd model)
        {
            model.UserId = CurrentUser.UserId;
            var intResult = UserBll.ChangePwd(model);
            if (intResult > 0)
            {
                if (model.PasswordType == PasswordType.登录密码)
                {
                    //清除cookie
                    Response.Cookies.Get(FormsAuthentication.FormsCookieName).Expires = DateTime.Now.AddYears(-1);
                    AjaxRespone.Msg = "修改成功,请重新登录";
                    AjaxRespone.Url = KeyHelper.USERCENTERURL;
                }
                AjaxRespone.Msg = "修改成功";
            }
            else
            {
                AjaxRespone.Msg = "原密码错误,请重试";
            }
            return Json(AjaxRespone);
        }
        private bool CheckValidCode(string code)
        {
            try
            {
                var verifkey = Session[KeyHelper.VERIFKEY].ToString();
                return string.Equals(code, verifkey, StringComparison.CurrentCultureIgnoreCase);
            }
            catch
            {
                return false;
            }
        }

        public ActionResult LogOut()
        {
            Response.Cookies.Get(FormsAuthentication.FormsCookieName).Expires = DateTime.Now.AddYears(-1);
            return Redirect(KeyHelper.USERCENTERURL);
        }
        public void QRCode()
        {
            var bit = HttpRuntime.Cache.Get(CurrentUser.UserIdentity) as System.Drawing.Bitmap;
            if (bit == null)
            {
                var finalPath = $"{path}/Order/Trans?u={CurrentUser.UserIdentity}";
                bit = QRCodeHelper.CreateQRImg(finalPath);
                HttpRuntime.Cache.Add(CurrentUser.UserIdentity, bit, new CacheDependency(null, new string[] { CurrentUser.UserIdentity }), DateTime.Now.AddYears(1), Cache.NoSlidingExpiration, CacheItemPriority.AboveNormal, null);

            }
            bit.Save(Response.OutputStream, System.Drawing.Imaging.ImageFormat.Bmp);
        }
    }
}