﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Security;
using Common;
using Models;
using Web.Modles;
using System.Threading;

namespace Web.Filter
{
    public class LoginFilterAttribute : AuthorizeAttribute
    {
        protected override bool AuthorizeCore(HttpContextBase httpContext)
        {
            var request = httpContext.Request;
            string cookieName = FormsAuthentication.FormsCookieName;
            var da = request.Cookies[cookieName];
            if (da != null)
            {
                try
                {
                    var userData = FormsAuthentication.Decrypt(da.Value.ToString()).UserData;
                    var user = userData.Deserialize<User>();
                    if (user != null)
                    {
                        httpContext.Items[KeyHelper.USERIDENTIRY] = user;
                        return true;
                    }
                }
                catch (Exception)
                {
                    return false;
                }

            }
            return false;
        }
        protected override void HandleUnauthorizedRequest(AuthorizationContext filterContext)
        {
            base.HandleUnauthorizedRequest(filterContext);

            filterContext.Result = new RedirectResult(KeyHelper.USERCENTERURL);
        }
    }
}