﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;

namespace Web.Modles
{
    public class MyRoute : Route
    {
        public MyRoute(string url, IRouteHandler handler) : base(url, handler)
        {
            Defaults = new RouteValueDictionary();
            Defaults.Add("controller", "Home");
            Defaults.Add("action", "Index");
            Defaults.Add("lange", "zh");
            Defaults.Add("id", UrlParameter.Optional);
        }
        public string Regx;
        public override RouteData GetRouteData(HttpContextBase httpContext)
        {
            var ttt = httpContext.Request.AppRelativeCurrentExecutionFilePath;
            RouteData routeData = base.GetRouteData(httpContext);
            var lan = httpContext.Request.Cookies["lange"];
            if (lan != null)
            {
                var culuter = lan.Value.ToString();//拿到当前语言
                if (!string.IsNullOrWhiteSpace(culuter))
                {
                    routeData.Values["lange"] = culuter;
                }
                else
                {
                    routeData.Values["lange"] = "zh";
                }
            }
            return routeData;
        }
    }
}